/*
** Copyright (C) 2017 by VisTracks, Inc
**
** THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF  VisTracks, Inc.
** The copyright notice above does not evidence any actual
** or intended publication of such source code.
*/

package com.vistracks.samplebluetoothmanager;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.Toast;

import java.util.Set;

public class MainActivity extends AppCompatActivity {
    private final static int REQUEST_ENABLE_BT = 1;
    final BluetoothAdapter btAdapter = BluetoothAdapter.getDefaultAdapter();
    String connector = null;
    BluetoothDevice btDevice = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
    }

    public void connectToPairedDevice(View view) {
        Intent intent = new Intent(this, DeviceListActivity.class);
        this.startActivity(intent);
    }

    public void startBluetooth(View view) {
        startBluetoothConnectionActivity();
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (resultCode == RESULT_OK && data != null) {
            String deviceAddress = data.getStringExtra("DeviceAddress");
            btDevice = btAdapter.getRemoteDevice(deviceAddress);
        }
        else {
            startBluetooth(null);
        }
    }

    protected void startBluetoothConnectionActivity() {
        if (connector == null) {
            Toast.makeText(this, "Please select the connector type.", Toast.LENGTH_SHORT);
        } else if (btDevice == null) {
            Toast.makeText(this, "Please connect to a paired bluetooth device.", Toast.LENGTH_SHORT);
        } else {
            Intent intent = new Intent(this, ATrackAx9BluetoothManager.class);
            intent.putExtra("connector", connector);
            intent.putExtra("device", btDevice);
            this.startActivity(intent);
        }
    }

    public void onRadioButtonClicked(View view) {
        // Is the button now checked?
        boolean checked = ((RadioButton) view).isChecked();

        switch(view.getId()) {
            case R.id.J1939:
                if (checked)
                    connector = "J1939";
                    break;
            case R.id.OBDII:
                if (checked)
                    connector = "OBDII";
                    break;
        }
    }
}
